equipes/urls.py
from django.conf.urls import url, include
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'', include('account.urls')),
    url(r'', include('o365.urls')),
]

o365/urls.py
from django.conf.urls import url, include
from django.contrib import admin

from o365 import views

app_name = 'o365'
urlpatterns = [
    url(r'^teams$', views.TeamsView.as_view(), name='teams'),
    url(r'^team/(?P<gid>[-\w]+)$', views.TeamView.as_view(), name='team'),
    url(r'^team/(?P<gid>[-\w]+)/clear$', views.ClearTeamView.as_view(), name='team_clear'),
    url(r'^team/(?P<gid>[-\w]+)/register$', views.RegisterMembersTeamView.as_view(), name='team_register'),
]

o365/models.py
from django.db import models

# Create your models here.

o365/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render, redirect

# Create your views here.
from django.urls import reverse
from django.views import View
from django.views.generic import TemplateView

from o365.microsoft import Microsoft
from o365.mixins import MicrosoftTeamMixin


class TeamsView(LoginRequiredMixin, TemplateView):
    template_name = 'o365/teams/teams.html'
    http_method_names = ['get']

    def get_context_data(self, **kwargs):
        data = super().get_context_data(**kwargs)
        data['teams'] = Microsoft().list_teams()
        return data


class RegisterMembersTeamView(MicrosoftTeamMixin, LoginRequiredMixin, View):
    template_name = 'import/register_user.html'
    http_method_names = ['post']

    def post(self, request, gid):
        m = Microsoft()
        users = [u.split(';') for u in request.POST['data'].split('\n')]
        for user in users:
            try:
                m.create_user(user[0], user[1])
            except IndexError:
                pass
        return redirect(reverse('o365:team', args=gid))


class TeamView(LoginRequiredMixin, TemplateView):
    template_name = 'o365/teams/team.html'

    def get_context_data(self, **kwargs):
        data = super().get_context_data(**kwargs)
        data['team'] = Microsoft().get_team(kwargs['gid'])
        data['members'] = Microsoft().get_members_of_team(kwargs['gid'])
        for i in range(0, len(data['members'])):
            odata_type = data['members'][i]['@odata.type']
            if odata_type == '#microsoft.graph.group':
                data['members'][i]['type'] = 'group'
            elif odata_type == '#microsoft.graph.user':
                data['members'][i]['type'] = 'user'
        return data


class ClearTeamView(MicrosoftTeamMixin, LoginRequiredMixin, TemplateView):
    template_name = 'o365/teams/clear_team.html'
    http_method_names = ['get', 'post']

    def post(self, _, gid):
        team = self.get_team(gid)
        members = self.api.get_members_of_team(gid)
        for member in members:
            if member['@odata.type'] == '#microsoft.graph.user':
                self.api.remove_member_from_team(member, team)
        return redirect(reverse('o365:team', kwargs={'gid': gid}))

o365/templates/o365/teams/clear_team.html
{% extends 'base.html' %}

{% block content %}
    <h1>Vider {{ team.displayName }}</h1>
    <p>Êtes vous sûr de vouloir vider le groupe de personnes : {{ team.displayName }} ?</p>
    <div class="text-center">
        <form method="post">
            {% csrf_token %}
            <button type="submit" class="btn btn-danger"><i class="fa fa-trash"></i> Oui, vider cette équipe</button>
            <a href="{% url 'o365:team' team.id %}" class="btn btn-success m-l-2">Non, je suis en train de faire une connerie !</a>
        </form>
    </div>
{% endblock %}

o365/templates/o365/teams/team.html
{% extends 'base.html' %}

{% block title %}{{ team.displayName }}{% endblock %}

{% block content %}
    <h1>
        <a href="{% url 'o365:teams' %}"><i class="fa fa-chevron-left "></i></a>
        {{ team.displayName }}</h1>
    <div class="row">
        <div class="col-md-4">
            <div class="card">
                <div class="card-header justify-content-between">
                    Membres
                    <a href="{% url 'o365:team_clear' team.id %}" class="pull-right btn btn-sm btn-outline-danger">
                        <i class="fa fa-trash"></i> Effacer
                    </a>
                </div>
                <div class="list-group list-group-flush ">
                    {% for member in members %}
                        {% if member.type == 'group' %}
                            <a href="{% url 'o365:team' member.id %}"
                               class="list-group-item list-group-item-action justify-content-between">
                                {{ member.displayName }}
                                <span class="badge badge-default badge-pill">Sous-groupe</span>
                            </a>
                        {% elif member.type == 'user' %}
                            <a href="{% url 'o365:team' member.id %}"
                               class="list-group-item list-group-item-action justify-content-between">
                                {{ member.displayName }}
                            </a>
                        {% else %}
                            <a href="{% url 'o365:team' member.id %}"
                               class="list-group-item list-group-item-action justify-content-between">
                                {{ member.displayName }}
                            </a>
                        {% endif %}
                    {% endfor %}
                </div>
            </div>
        </div>
    </div>
{% endblock %}

o365/templates/o365/teams/teams.html
{% extends 'base.html' %}

{% block content %}
    <div class="row">
        <div class="col-md-12">
            <h1>Equipes</h1>
            <div class="list-group">
                {% for team in teams %}
                    <a href="{% url 'o365:team' team.id %}"
                       class="list-group-item list-group-item-action justify-content-between">
                        {{ team.displayName }}
                        {% if team.mail %}
                            <span class="badge badge-default badge-pill">{{ team.mail }}</span>
                        {% endif %}
                    </a>
                {% endfor %}
            </div>
        </div>
    </div>
{% endblock %}

o365/templates/o365/teams/user.html
{% extends 'base.html' %}

{% block content %}
    <div class="row">
        <div class="col-md-12">
            <h1>
                <a href="{% url 'o365:team' team.id %}"><i class="fa fa-chevron-left "></i></a>
                {{ user.displayName }}
            </h1>
        </div>
        <div class="col-md-4">

        </div>
    </div>
{% endblock %}